<%--
 * Component: dotcom
 *
 * Description:
 *
 * Parameters:
 *
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@
	page import="java.util.*, java.sql.ResultSet, java.math.BigInteger,
			imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			imagemed.imtables.IMBaseFieldManager, imagemed.expression.IMExpressionContext,
			imagemed.scheduler.SchedulerInterface"

%><%@
	page errorPage="../main/exceptionHandler.jsp"

%><%!

  static Syslog operLogger = new Syslog( "logtime.jsp", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );

%><%
	IMSession is = new IMSession(request, response, out);

	if ( !IfaceToolbox.isRegOK( is, true ) ) {
		out.println( "#RESULT: FAILED - login" );
		return;
	}

	String time = is.request.getParameter( "cTime" );
	Helper.DEBUG( "logtime.jsp", "time:" + time );
	String parentHost = "";
	try {
		parentHost = DotcomToolbox.getParentID();
	}
	catch ( Throwable th ) {
	}

	GregorianCalendar calMother = Helper.getCalendarFromDate( time );
	BigInteger secondsMother = IMExpressionContext.getSecondsFromCalendar( calMother );

	GregorianCalendar calMe = new GregorianCalendar();
	BigInteger secondsMe = IMExpressionContext.getSecondsFromCalendar( calMe );

	int corrigSeconds = secondsMe.subtract( secondsMother ).intValue();
	
	try {
		String timediffDbName = IMBaseFieldManager.staticGetDbName( "0LTD" ); 
		ResultSet rs = IMEnv.getDB().createStatement().executeQuery( "select " + timediffDbName +
			" from " + IMEnvBase.getEnv( "SCHEDULERLOGTBL" ) + " where " +
			IMBaseFieldManager.staticGetDbName("0LAC") + "='timestamp' order by concat(LOGEVENTDATE,LOGEVENTTIME) DESC LIMIT 1" );
		if ( rs.next() ) {
			String lastSecondsStr = rs.getString( timediffDbName );
			if ( lastSecondsStr != null ) {
				int lastSeconds = Integer.parseInt( lastSecondsStr );
				if ( Math.abs( corrigSeconds - lastSeconds ) <= OperLogEntry.TIME_LOGGING_EPSILON_SECONDS ) {
					Helper.DEBUG( "Timestamp wasn't logged because diff is less then epsilon" );
					return;
				}
			}
		}
	}
	catch ( Throwable th ) {
		Helper.ERRORLOG( "Exception:" + Helper.throwable2String( th ) );
	}
		
	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.TIMESTAMP, "timestamp" );
	logEntry.setField( OperLogEntry.FIELD.USER, "system" );
	logEntry.setField( OperLogEntry.FIELD.TIMESTAMP_DIFFSECONDS, "" + corrigSeconds );
	logEntry.setField( OperLogEntry.FIELD.TIMESTAMP_PARENT, parentHost );
	logEntry.log( operLogger, Syslog.LOG_INFO );

//	operLogger.syslog( Syslog.LOG_INFO, "INFO TIMESTAMP timestamp system " + corrigSeconds + " " + parentHost );
	
%>